(*

Das Paket libsqlite3-dev mus installiert werden.

sudo aptitude install libsqlite3-dev

Der SQLite Befehlssatz unterscheidet sich ein klein wenig zu MySQL

für mehr Details siehe :

http://www.sqlite.org/sqlite.html

*)

Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DbCtrls, sqldb, sqlite3conn, mysql50conn, db, math;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Function ToLen(Len: Integer; value: String): String;
Begin
  While length(value) < len Do
    value := ' ' + value;
  result := value;
End;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  (* Alle Einstellungen die gemacht werden müssen, geht natürlich auch im OE*)
  (*
   * Die Komponente die die verbindung zum SQL-Server aufbaut
   *)
  SQLite3Connection1.DatabaseName := 'testdb1'; // Name der Datenbank, case sensitiv
  SQLite3Connection1.Password := ''; // Kein Passwort
  SQLite3Connection1.UserName := ''; // Keine Ahnung für was das ist
  SQLite3Connection1.Transaction := SQLTransaction1;
  (*
   * Transaction Komponente
   *)
  SQLTransaction1.DataBase := SQLite3Connection1;
  (*
   * Die Query Komponente
   *)
  SQLQuery1.DataBase := SQLite3Connection1;
  SQLQuery1.Transaction := SQLTransaction1;
  (*
   * Eine erste Query, diese zeigt alle Tabellen in der DB an.
   *)
  memo1.clear;
  memo1.lines.add('SELECT name FROM sqlite_master');
  memo1.lines.add('    WHERE type IN (''table'',''view'') AND name NOT LIKE ''sqlite_%''');
  memo1.lines.add('    UNION ALL');
  memo1.lines.add('    SELECT name FROM sqlite_temp_master');
  memo1.lines.add('    WHERE type IN (''table'',''view'')');
  memo1.lines.add('    ORDER BY 1');
  SQLite3Connection1.Connected := true;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Type

  TCol = Record
    MaxLen: Integer;
    Data: Array Of String;
  End;

  TTableCache = Array Of TCol;

Var
  st: String;
  f: TField;
  s: TStringlist;
  a: TTableCache;
  j, c, i: Integer;
Begin
  SQLQuery1.Active := false;
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Text := memo1.Text;
  SQLQuery1.Open;
  // Wenn überhaupt etwas ausgelesen werden konnte
  setlength(a, 0);
  If SQLQuery1.Fields.Count <> 0 Then Begin
    setlength(a, SQLQuery1.Fields.Count);
    // Die Labels Setzen
    s := TStringlist.create;
    SQLQuery1.Fields.GetFieldNames(s);
    For i := 0 To s.count - 1 Do Begin
      setlength(a[i].Data, 1);
      a[i].Data[0] := s[i];
      a[i].MaxLen := length(s[i]);
    End;
    // Auslesen aller gesendeter Daten
    While (Not SQLQuery1.EOF) Do Begin
      For i := 0 To s.count - 1 Do Begin
        setlength(a[i].Data, high(a[i].Data) + 2);
        f := SQLQuery1.Fields.FieldByName(s[i]);
        If assigned(f) Then Begin
          Case f.DataType Of
            ftInteger: a[i].Data[high(a[i].Data)] := inttostr(f.AsInteger);
            ftString: a[i].Data[high(a[i].Data)] := f.AsString;
          End;
          a[i].MaxLen := max(a[i].MaxLen, length(a[i].Data[high(a[i].Data)]));
        End;
      End;
      SQLQuery1.Next;
    End;
    s.free;
  End;
  // Löschen der Alten Ausgabe
  memo2.Clear;
  // Konvertierung der Ausgabe
  If assigned(a) Then Begin
    For j := 0 To high(a[0].Data) Do Begin
      st := '';
      For i := 0 To high(a) Do Begin
        If i <> high(a) Then
          st := st + ToLen(a[i].MaxLen, a[i].Data[j]) + '|'
        Else
          st := st + ToLen(a[i].MaxLen, a[i].Data[j]);
      End;
      memo2.Lines.add(st);
      If j = 0 Then Begin
        c := length(st);
        st := '';
        While length(st) < c Do
          st := st + '-';
        memo2.Lines.add(st);
      End;
    End;
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  SQLQuery1.Active := false;
  SQLQuery1.SQL.Clear;
  SQLQuery1.SQL.Text := memo1.Text;
  SQLQuery1.ExecSQL;
  SQLTransaction1.Commit;
  // Keine Ausgabe
  memo2.Clear;
End;

End.

